SCRIPT_TIME_START=$(date +%Y%m%dT%H%M%S.%N);
PATH="$HOME/.local/bin:$PATH"; # Add "$(systemd-path user-binaries)" path in case apps saved there
SCRIPT_HOSTNAME=$(hostname); # Save hostname of system running this script.
-SCRIPT_VERSION="bkgpslog 0.1.0"; # Define version of script.
+SCRIPT_VERSION="0.2.2"; # Define version of script.
+SCRIPT_NAME="bkgpslog"; # Define basename of script file.
+SCRIPT_URL="https://gitlab.com/baltakatei/ninfacyzga-01"; # Define wesite hosting this script.
+AGE_VERSION="1.0.0-beta2"; # Define version of age (encryption program)
+AGE_URL="https://github.com/FiloSottile/age/releases/tag/v1.0.0-beta2"; # Define website hosting age.
declare -Ag appRollCall # Associative array for storing app status
declare -Ag fileRollCall # Associative array for storing file status
} # Exports TZ environment variable
timeUntilNextDay(){
# Desc: Report seconds until next day.
+ # Version: 1.0.0
# Output: stdout: integer seconds until next day
# Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
# Usage: timeUntilNextDay
# Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
+ # Depends: date 8, echo 8, yell, try
+
local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
+
TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
returnState="true";
elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
- returnState="WARNING_ZERO";
+ returnState="warning_zero";
yell "WARNING:Reported time until next day exactly zero.";
elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
- returnState="WARNING_NEGATIVE";
+ returnState="warning_negative";
yell "WARNING:Reported time until next day is negative.";
fi
try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
- #===Determine function return code===
+ # Determine function return code
if [[ "$returnState" = "true" ]]; then
return 0;
- elif [[ "$returnState" = "WARNING_ZERO" ]]; then
+ elif [[ "$returnState" = "warning_zero" ]]; then
return 1;
- elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
+ elif [[ "$returnState" = "warning_negative" ]]; then
return 2;
fi
} # Report seconds until next day
timeUntilNextHour(){
# Desc: Report seconds until next hour
+ # Version 1.0.0
# Output: stdout: integer seconds until next hour
# Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
# Usage: timeUntilNextHour
# Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
+
local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
TIME_CURRENT="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
TIME_NEXT_HOUR="$(date -d "$TIME_CURRENT next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
returnState="true";
elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
- returnState="WARNING_ZERO";
+ returnState="warning_zero";
yell "WARNING:Reported time until next hour exactly zero.";
elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
- returnState="WARNING_NEGATIVE";
+ returnState="warning_negative";
yell "WARNING:Reported time until next hour is negative.";
fi
try echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
- #===Determine function return code===
+ # Determine function return code
if [[ "$returnState" = "true" ]]; then
return 0;
- elif [[ "$returnState" = "WARNING_ZERO" ]]; then
+ elif [[ "$returnState" = "warning_zero" ]]; then
return 1;
- elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
+ elif [[ "$returnState" = "warning_negative" ]]; then
return 2;
fi
} # Report seconds until next hour
echo "$DATE_CURRENT_SHORT";
} # Get YYYYmmdd
timeDuration(){
- # Desc: Output approximate time duration string before given time (default:current date)
+ # Desc: Given seconds, output ISO-8601 duration string
# Ref/Attrib: ISO-8601:2004(E), §4.4.4.2 Representations of time intervals by duration and context information
# Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), §2.2.1.2)
- # Usage: timeDuration [arg1] ([arg2])
+ # Usage: timeDuration [1:seconds] ([2:precision])
+ # Version: 1.0.3
# Input: arg1: seconds as base 10 integer >= 0 (ex: 3601)
# arg2: precision level (optional; default=2)
# Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
+ # exit code 0: success
+ # exit code 1: error_input
+ # exit code 2: error_unknown
# Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
- # Depends: date 8 (gnucoreutils)
- local returnState fullHours fullMinutes fullSeconds;
- ARG1="$1";
- ARG2="$2";
+ # Depends: date 8 (gnucoreutils), yell,
+ local returnState argSeconds argPrecision remainder precision witherPrecision
+ local fullYears fullMonths fullDays fullHours fullMinutes fullSeconds
+ local displayYears displayMonths displayDays displayHours displayMinutes displaySeconds
+ local hasYears hasMonths hasDays hasHours hasMinutes hasSeconds
+
+ argSeconds="$1"; # read arg1 (seconds)
+ argPrecision="$2"; # read arg2 (precision)
precision=2; # set default precision
- returnState="true"; # set default return state
# Check that between one and two arguments is supplied
if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
yell "ERROR:Invalid number of arguments:$# . Exiting.";
- returnState="ERROR_INPUT"; fi
+ returnState="error_input"; fi
- # Check that arg1 provided
+ # Check that argSeconds provided
if [[ $# -ge 1 ]]; then
- # Check that arg1 is a positive integer
- if [[ "$ARG1" =~ ^[[:digit:]]+$ ]]; then
- arg1Valid="true";
+ ## Check that argSeconds is a positive integer
+ if [[ "$argSeconds" =~ ^[[:digit:]]+$ ]]; then
+ :
else
- yell "ERROR:ARG1 not a digit.";
- returnState="ERROR_INPUT";
- arg1Valid="false";
+ yell "ERROR:argSeconds not a digit.";
+ returnState="error_input";
fi
else
yell "ERROR:No argument provided. Exiting.";
exit 1;
fi
- # Consider whether arg2 was provided
+ # Consider whether argPrecision was provided
if [[ $# -eq 2 ]]; then
- # Check that the second arg is a positive integer
- if [[ "$ARG2" =~ ^[[:digit:]]+$ ]] && [[ "ARG2" -gt 0 ]]; then
- arg2Valid="true";
- precision="$ARG2";
+ # Check that argPrecision is a positive integer
+ if [[ "$argPrecision" =~ ^[[:digit:]]+$ ]] && [[ "$argPrecision" -gt 0 ]]; then
+ precision="$argPrecision";
else
- yell "ERROR:ARG2 not a positive integer. (is $ARG2 ). Leaving early.";
- returnState="ERROR_INPUT";
- arg2Valid="false";
+ yell "ERROR:argPrecision not a positive integer. (is $argPrecision ). Leaving early.";
+ returnState="error_input";
fi;
else
- arg2Valid="false";
+ :
fi;
- remainder="$ARG1" ; # seconds
+ remainder="$argSeconds" ; # seconds
## Calculate full years Y, update remainder
fullYears=$(( remainder / (365*24*60*60) ));
remainder=$(( remainder - (fullYears*365*24*60*60) ));
fi;
if $witherPrecision; then ((precision--)); fi;
-
-
## Determine whether or not the "T" separator is needed to separate date and time elements
if ( $displayHours || $displayMinutes || $displaySeconds); then
displayDateTime="true"; else displayDateTime="false"; fi
OUTPUT=$OUTPUT$fullSeconds"S"; fi
## Output duration string to stdout
- if [[ "$returnState" = "true" ]]; then echo "$OUTPUT"; fi
+ echo "$OUTPUT" && returnState="true";
#===Determine function return code===
if [ "$returnState" = "true" ]; then
return 0;
- else
- echo "$returnState" 1>&2;
+ elif [ "$returnState" = "error_input" ]; then
+ yell "ERROR:input";
return 1;
+ else
+ yell "ERROR:Unknown";
+ return 2;
fi
} # Get duration (ex: PT10M4S )
try tar --append --directory="$TMP_DIR" --file="$TAR_PATH" "$FILENAME";
yell "DEBUG:STATUS:$FN:Finished appendArgTar()."
} # Append Bash var to file appended to Tar archive
+magicWriteVersion() {
+ # Desc: Appends time-stamped VERSION to PATHOUT_TAR
+ # Usage: magicWriteVersion
+ # Version: 0.1.0
+ # Input: CONTENT_VERSION, FILEOUT_VERSION, PATHOUT_TAR, DIR_TMP
+ # Input: SCRIPT_VERSION, SCRIPT_URL, AGE_VERSION, AGE_URL, SCRIPT_HOSTNAME
+ # Output: appends tar PATHOUT_TAR
+ # Depends: dateTimeShort, appendArgTar
+ local CONTENT_VERSION pubKeyIndex
+
+ # Set VERSION file name
+ FILEOUT_VERSION="$(dateTimeShort)..VERSION";
+
+ # Gather VERSION data in CONTENT_VERSION
+ CONTENT_VERSION="SCRIPT_VERSION=$SCRIPT_VERSION";
+ #CONTENT_VERSION="$CONTENT_VERSION""\n";
+ CONTENT_VERSION="$CONTENT_VERSION""\n""SCRIPT_NAME=$SCRIPT_NAME";
+ CONTENT_VERSION="$CONTENT_VERSION""\n""SCRIPT_URL=$SCRIPT_URL";
+ CONTENT_VERSION="$CONTENT_VERSION""\n""AGE_VERSION=$AGE_VERSION";
+ CONTENT_VERSION="$CONTENT_VERSION""\n""AGE_URL=$AGE_URL";
+ CONTENT_VERSION="$CONTENT_VERSION""\n""DATE=$(date --iso-8601=seconds)";
+ CONTENT_VERSION="$CONTENT_VERSION""\n""HOSTNAME=$SCRIPT_HOSTNAME";
+ ## Add list of recipient pubkeys
+ for pubkey in "${recPubKeysValid[@]}"; do
+ ((pubKeyIndex++))
+ CONTENT_VERSION="$CONTENT_VERSION""\n""PUBKEY_$pubKeyIndex=$pubkey";
+ done
+ ## Process newline escapes
+ CONTENT_VERSION="$(echo -e "$CONTENT_VERSION")"
+
+ # Write CONTENT_VERSION as file FILEOUT_VERSION and write-append to PATHOUT_TAR
+ appendArgTar "$CONTENT_VERSION" "$FILEOUT_VERSION" "$PATHOUT_TAR" "$DIR_TMP";
+
+} # bkgpslog: write version data to PATHOUT_TAR via appendArgTar()
magicWriteBuffer() {
# Desc: bkgpslog-specific meta function for writing data to DIR_TMP then appending each file to PATHOUT_TAR
# Inputs: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP
wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
vbm "DEBUG:STATUS:$FN:Started magicWriteBuffer().";
- # Check that PATHOUT_TAR is a tar. Rename old and create empty one otherwise.
- checkMakeTar "$PATHOUT_TAR"
+ # Validate PATHOUT_TAR as tar.
+ checkMakeTar "$PATHOUT_TAR";
+ ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+ if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
# Write bufferBash to PATHOUT_TAR
appendArgTar "$bufferBash" "$FILEOUT_NMEA" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_NMEA" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write NMEA data
yell "DEBUG:STATUS:$FN:Finished magicWriteBuffer().";
} # bkgpslog write function
-
main() {
processArguments "$@" # Process arguments.
for pubkey in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
vbm "DEBUG:Testing pubkey string:$pubkey"
if echo "butts" | age -a -r "$pubkey" 1>/dev/null; then
- # Form age recipient string
+ #### Form age recipient string
recipients="$recipients""-r $pubkey ";
vbm "STATUS:Added pubkey for forming age recipient string:""$pubkey";
vbm "DEBUG:recipients:""$recipients";
+ #### Add validated pubkey to recPubKeysValid array
+ recPubKeysValid+=("$pubkey") && vbm "DEBUG:recPubkeysValid:pubkey added:$pubkey";
else
yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
fi
done
vbm "DEBUG:Finished processing recPubKeys array";
- # Form age command string
+
+ ## Form age command string
CMD_ENCRYPT="age ""$recipients ";
CMD_ENCRYPT_SUFFIX=".age";
else
displayMissing; yell "Exiting."; exit 1; fi
# Set script lifespan
- setScriptTTL "$SCRIPT_TTL";
+ setScriptTTL "$SCRIPT_TTL"; # seconds until next new SCRIPT_TTL (ex: "day" or "hour")
# File name substring: encoded bufferTTL
bufferTTL_STR="$(timeDuration $BUFFER_TTL)";
## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
- ## Generate VERSION file
- FILEOUT_VERSION="$(dateTimeShort)..VERSION";
- PATHOUT_VERSION="$DIR_TMP"/"$FILEOUT_VERSION";
- echo "$(dateTimeShort):$(basename "$0")"" Version:""$SCRIPT_VERSION" >> "$PATHOUT_VERSION" && vbm "DEBUG:VERSION created:$PATHOUT_VERSION";
-
## Check that PATHOUT_TAR is a tar. Rename old and create empty one otherwise.
checkMakeTar "$PATHOUT_TAR" && vbm "DEBUG:Confirmed or Created to be a tar:$PATHOUT_TAR";
-
## Append VERSION file to PATHOUT_TAR
- try tar --append --directory="$DIR_TMP" --file="$PATHOUT_TAR" "$FILEOUT_VERSION" && \
- vbm "DEBUG:VERSION added to $PATHOUT_TAR";
+ magicWriteVersion;
# Record gps data until script lifespan ends
declare debugCounter; debugCounter="0"; # set debug counter